//'Copyright 2004 Seapine Software, Inc. All rights reserved.
//
//IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
//in consideration of your agreement to the following terms, and your use, installation,
//modification or redistribution of this Software constitutes acceptance of these terms.
//If you do not agree with these terms, please do not use, install, modify or redistribute
//this Software.
//
//In consideration of your agreement to abide by the following terms, and subject to these
//terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
//this original Seapine software (the Software), to use, reproduce, modify and redistribute
//the Software, with or without modifications, in source and/or binary forms; provided that
//if you redistribute the Software in its entirety and without modifications, you must retain
//this notice and the following text and disclaimers in all such redistributions of the Software.
//Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
//or promote products derived from the Software without specific prior written permission from
//Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
//implied, are granted by Seapine herein, including but not limited to any patent rights that
//may be infringed by your derivative works or by other works in which the Software may be
////incorporated.
//
//The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
//EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
//MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
//OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
//
//IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
//DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
//REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
//UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
//IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//******************************************************************************

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;

namespace TTPRSSFeed
{
	/// <summary>
	/// Summary description for MainDlg.
	/// </summary>
	public class MainDlg : System.Windows.Forms.Form
	{
		public static int Main()
		{
			MainDlg main = new MainDlg();
			main.ShowDialog();

			return (0);
		}

		private System.Windows.Forms.Label labelPassword;
		private System.Windows.Forms.Label labelUsername;
		private System.Windows.Forms.TextBox editPassword;
		private System.Windows.Forms.Button buttonClose;
		private ttsoapcgi m_cgiEngine;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox editServer;
		private System.Windows.Forms.TextBox editPort;
		private System.Windows.Forms.Button buttonConnect;
		private System.Windows.Forms.TextBox editUsername;
		private System.Windows.Forms.TextBox editLastRefreshed;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Button buttonStartFeed;
		private System.Windows.Forms.NumericUpDown spinInterval;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button buttonStopFeed;
		private System.Windows.Forms.ListView listStatus;
		private long m_lThreads = 0;
		private System.Threading.Thread[] m_athread;
		private TTPRSSFeed.Thread[] m_arssthread;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.CheckedListBox listDatabase;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox editPath;
		private Mutex m_mutex = new Mutex();
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.Label label5;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainDlg()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			buttonStopFeed.Enabled = false;

			m_cgiEngine = new ttsoapcgi();

			retrieveServerDefaults();
			populateDatabaseList();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainDlg));
			this.buttonClose = new System.Windows.Forms.Button();
			this.labelPassword = new System.Windows.Forms.Label();
			this.labelUsername = new System.Windows.Forms.Label();
			this.editPassword = new System.Windows.Forms.TextBox();
			this.editUsername = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.editServer = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.editPort = new System.Windows.Forms.TextBox();
			this.buttonConnect = new System.Windows.Forms.Button();
			this.editLastRefreshed = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label4 = new System.Windows.Forms.Label();
			this.buttonStartFeed = new System.Windows.Forms.Button();
			this.spinInterval = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.buttonStopFeed = new System.Windows.Forms.Button();
			this.listStatus = new System.Windows.Forms.ListView();
			this.listDatabase = new System.Windows.Forms.CheckedListBox();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.editPath = new System.Windows.Forms.TextBox();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.label5 = new System.Windows.Forms.Label();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.spinInterval)).BeginInit();
			this.SuspendLayout();
			// 
			// buttonClose
			// 
			this.buttonClose.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonClose.Location = new System.Drawing.Point(384, 400);
			this.buttonClose.Name = "buttonClose";
			this.buttonClose.Size = new System.Drawing.Size(80, 25);
			this.buttonClose.TabIndex = 9;
			this.buttonClose.Text = "Close";
			this.buttonClose.Click += new System.EventHandler(this.buttonClose_Click);
			// 
			// labelPassword
			// 
			this.labelPassword.Location = new System.Drawing.Point(16, 224);
			this.labelPassword.Name = "labelPassword";
			this.labelPassword.Size = new System.Drawing.Size(64, 16);
			this.labelPassword.TabIndex = 20;
			this.labelPassword.Text = "Password:";
			// 
			// labelUsername
			// 
			this.labelUsername.Location = new System.Drawing.Point(16, 200);
			this.labelUsername.Name = "labelUsername";
			this.labelUsername.Size = new System.Drawing.Size(64, 16);
			this.labelUsername.TabIndex = 19;
			this.labelUsername.Text = "Username:";
			// 
			// editPassword
			// 
			this.editPassword.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editPassword.Location = new System.Drawing.Point(80, 224);
			this.editPassword.Name = "editPassword";
			this.editPassword.Size = new System.Drawing.Size(192, 20);
			this.editPassword.TabIndex = 2;
			this.editPassword.Text = "";
			// 
			// editUsername
			// 
			this.editUsername.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editUsername.Location = new System.Drawing.Point(80, 200);
			this.editUsername.Name = "editUsername";
			this.editUsername.Size = new System.Drawing.Size(192, 20);
			this.editUsername.TabIndex = 1;
			this.editUsername.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 16);
			this.label2.TabIndex = 23;
			this.label2.Text = "Server:";
			// 
			// editServer
			// 
			this.editServer.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editServer.Location = new System.Drawing.Point(72, 24);
			this.editServer.Name = "editServer";
			this.editServer.Size = new System.Drawing.Size(176, 20);
			this.editServer.TabIndex = 4;
			this.editServer.Text = "";
			this.editServer.TextChanged += new System.EventHandler(this.editServer_TextChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(256, 24);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(32, 16);
			this.label3.TabIndex = 25;
			this.label3.Text = "Port:";
			// 
			// editPort
			// 
			this.editPort.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editPort.Location = new System.Drawing.Point(288, 24);
			this.editPort.Name = "editPort";
			this.editPort.Size = new System.Drawing.Size(56, 20);
			this.editPort.TabIndex = 5;
			this.editPort.Text = "";
			this.editPort.TextChanged += new System.EventHandler(this.editPort_TextChanged);
			// 
			// buttonConnect
			// 
			this.buttonConnect.Location = new System.Drawing.Point(352, 24);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(88, 25);
			this.buttonConnect.TabIndex = 6;
			this.buttonConnect.Text = "Get Databases";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// editLastRefreshed
			// 
			this.editLastRefreshed.BackColor = System.Drawing.SystemColors.Control;
			this.editLastRefreshed.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.editLastRefreshed.Enabled = false;
			this.editLastRefreshed.Location = new System.Drawing.Point(88, 400);
			this.editLastRefreshed.Name = "editLastRefreshed";
			this.editLastRefreshed.Size = new System.Drawing.Size(208, 13);
			this.editLastRefreshed.TabIndex = 28;
			this.editLastRefreshed.Text = "";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.editPort);
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.editServer);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.buttonConnect);
			this.groupBox2.Location = new System.Drawing.Point(16, 16);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(448, 56);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Server Connection";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 400);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 16);
			this.label4.TabIndex = 23;
			this.label4.Text = "Last refresh:";
			// 
			// buttonStartFeed
			// 
			this.buttonStartFeed.Location = new System.Drawing.Point(288, 240);
			this.buttonStartFeed.Name = "buttonStartFeed";
			this.buttonStartFeed.Size = new System.Drawing.Size(80, 25);
			this.buttonStartFeed.TabIndex = 3;
			this.buttonStartFeed.Text = "Start Feed";
			this.buttonStartFeed.Click += new System.EventHandler(this.buttonStartFeed_Click);
			// 
			// spinInterval
			// 
			this.spinInterval.BackColor = System.Drawing.SystemColors.Window;
			this.spinInterval.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.spinInterval.Increment = new System.Decimal(new int[] {
																		   5,
																		   0,
																		   0,
																		   0});
			this.spinInterval.Location = new System.Drawing.Point(368, 200);
			this.spinInterval.Maximum = new System.Decimal(new int[] {
																		 900,
																		 0,
																		 0,
																		 0});
			this.spinInterval.Minimum = new System.Decimal(new int[] {
																		 15,
																		 0,
																		 0,
																		 0});
			this.spinInterval.Name = "spinInterval";
			this.spinInterval.ReadOnly = true;
			this.spinInterval.Size = new System.Drawing.Size(40, 20);
			this.spinInterval.TabIndex = 7;
			this.spinInterval.Value = new System.Decimal(new int[] {
																	   30,
																	   0,
																	   0,
																	   0});
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(288, 200);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 16);
			this.label1.TabIndex = 32;
			this.label1.Text = "Refresh every";
			// 
			// buttonStopFeed
			// 
			this.buttonStopFeed.Location = new System.Drawing.Point(384, 240);
			this.buttonStopFeed.Name = "buttonStopFeed";
			this.buttonStopFeed.Size = new System.Drawing.Size(80, 25);
			this.buttonStopFeed.TabIndex = 8;
			this.buttonStopFeed.Text = "Stop Feed";
			this.buttonStopFeed.Click += new System.EventHandler(this.buttonStopFeed_Click);
			// 
			// listStatus
			// 
			this.listStatus.AutoArrange = false;
			this.listStatus.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.listStatus.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.columnHeader1});
			this.listStatus.FullRowSelect = true;
			this.listStatus.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None;
			this.listStatus.ImeMode = System.Windows.Forms.ImeMode.NoControl;
			this.listStatus.LabelWrap = false;
			this.listStatus.Location = new System.Drawing.Point(16, 280);
			this.listStatus.MultiSelect = false;
			this.listStatus.Name = "listStatus";
			this.listStatus.Size = new System.Drawing.Size(448, 112);
			this.listStatus.TabIndex = 34;
			this.listStatus.View = System.Windows.Forms.View.Details;
			// 
			// listDatabase
			// 
			this.listDatabase.Location = new System.Drawing.Point(16, 96);
			this.listDatabase.Name = "listDatabase";
			this.listDatabase.Size = new System.Drawing.Size(448, 94);
			this.listDatabase.TabIndex = 35;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(16, 80);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(64, 16);
			this.label6.TabIndex = 36;
			this.label6.Text = "Databases:";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 248);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(64, 16);
			this.label7.TabIndex = 37;
			this.label7.Text = "Local Path:";
			// 
			// editPath
			// 
			this.editPath.Cursor = System.Windows.Forms.Cursors.IBeam;
			this.editPath.Location = new System.Drawing.Point(80, 248);
			this.editPath.Name = "editPath";
			this.editPath.Size = new System.Drawing.Size(192, 20);
			this.editPath.TabIndex = 6;
			this.editPath.Text = "c:\\inetpub\\wwwroot\\ttweb\\rss\\";
			// 
			// columnHeader1
			// 
			this.columnHeader1.Width = 440;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(408, 200);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(48, 16);
			this.label5.TabIndex = 38;
			this.label5.Text = "minutes";
			// 
			// MainDlg
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(474, 440);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.editPath);
			this.Controls.Add(this.label7);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.listDatabase);
			this.Controls.Add(this.listStatus);
			this.Controls.Add(this.buttonStopFeed);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.spinInterval);
			this.Controls.Add(this.buttonStartFeed);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.editLastRefreshed);
			this.Controls.Add(this.buttonClose);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.editUsername);
			this.Controls.Add(this.editPassword);
			this.Controls.Add(this.labelUsername);
			this.Controls.Add(this.labelPassword);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainDlg";
			this.Text = "TestTrack Pro - RSS Feed";
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.spinInterval)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void retrieveServerDefaults()
		{
			try
			{
				string strServer = "", strPort = "";

				// -meh. Read from saved values!

				if (strServer.Length == 0)	{ strServer = "127.0.0.1"; }
				if (strPort.Length == 0)	{ strPort = "80"; }

				editServer.Text = strServer;
				editPort.Text = strPort;

				m_cgiEngine.Url = buildUrl(strServer + ":" + strPort);
			}
			catch (Exception) {}
		}

		public void writeStatus(string p_str)
		{
			// -meh. Is this needed?
			m_mutex.WaitOne();
			listStatus.Items.Add( DateTime.Now.ToString("M/dd H:mm") + ": " + p_str);
			m_mutex.ReleaseMutex();
		}

		public void writeRefresh()
		{
			// -meh. Is this needed?
			m_mutex.WaitOne();
			editLastRefreshed.Text = System.DateTime.Now.ToShortDateString() + " " + System.DateTime.Now.ToShortTimeString();
			m_mutex.ReleaseMutex();
		}

		private void populateDatabaseList()
		{
			Cursor = Cursors.WaitCursor;
			try
			{
				listDatabase.Items.Clear();

				CDatabase[] adb = m_cgiEngine.getDatabaseList();
				if (adb != null && adb.Length > 0)
				{
					for (int i = 0; i < adb.Length; ++i) { listDatabase.Items.Add( adb[i].name); }
				}
			}
			catch (Exception)
			{
				MessageBox.Show( this,
								 "Unable to retrieve databases for the server at " + editServer.Text+":"+editPort.Text + ". \nMake sure the server and port connection parameters are correct. \nNote that the default port for SOAP services is 80.",
								 "Error fetching databases", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}

			Cursor = Cursors.Default;
		}

		private bool launchThread(string p_strDatabase)
		{
			Cursor = Cursors.WaitCursor;

			m_arssthread[m_lThreads] = new Thread( this, m_cgiEngine, editPath.Text, p_strDatabase, editUsername.Text, editPassword.Text, System.Convert.ToInt32(spinInterval.Text));
			m_athread[m_lThreads] = new System.Threading.Thread(new System.Threading.ThreadStart(m_arssthread[m_lThreads].Handler));
			m_athread[m_lThreads].Start();

			while (!m_athread[m_lThreads].IsAlive);
			++m_lThreads;

			Cursor = Cursors.Default;
			return (true);
		}

		private void buttonConnect_Click(object sender, System.EventArgs e)
		{
			try
			{
				m_cgiEngine.Url = buildUrl(editServer.Text + ":" + editPort.Text);
			}
			catch (Exception) {}

			populateDatabaseList();
		}

		private void editServer_TextChanged(object sender, System.EventArgs e)
		{
			buttonConnect.Enabled = (editServer.Text.Length > 0 && editPort.Text.Length > 0);
		}

		private void editPort_TextChanged(object sender, System.EventArgs e)
		{
			buttonConnect.Enabled = (editServer.Text.Length > 0 && editPort.Text.Length > 0);
		}

		private string buildUrl(string p_strIPPort)
		{
			string str = "http://";
			str += p_strIPPort;
			str += "/scripts/ttsoapcgi.exe";
			return (str);
		}

		private void stopThreads()
		{
			for (long l = m_lThreads-1; l >= 0; --l)
			{
				m_arssthread[l].Abort();
				m_athread[l].Abort();
				m_athread[l] = null;
				m_arssthread[l] = null;
			}
			m_lThreads = 0;
		}

		private void buttonStopFeed_Click(object sender, System.EventArgs e)
		{
			stopThreads();
			enableCtrls(true);
		}

		private void buttonStartFeed_Click(object sender, System.EventArgs e)
		{
			listStatus.Items.Clear();
			m_lThreads = 0;
			m_athread = new System.Threading.Thread[listDatabase.CheckedItems.Count];
			m_arssthread = new Thread[listDatabase.CheckedItems.Count];

			string strError;
			foreach (object item in listDatabase.CheckedItems)
			{
				try
				{
					long lCookie = m_cgiEngine.DatabaseLogon( item.ToString(), editUsername.Text, editPassword.Text);
					if (lCookie > 0)
					{
						m_cgiEngine.DatabaseLogoff(lCookie);
						launchThread(item.ToString());
						strError = "Successfully launched rss feed for '" + item.ToString() + "' database.";
						enableCtrls(false);
					}
					else
						strError = "Unable to login to '" + item.ToString() + "' as " + editUsername.Text + "!";
				}
				catch (Exception exception)
				{
					strError = "Error launching rss feed for '" + item.ToString() + "' database: " + exception.Message;
				}

				if (strError.Length > 0) { writeStatus(strError); }
			}
		}

		private void enableCtrls(bool p_fEnable)
		{
			editServer.Enabled = p_fEnable;
			editPort.Enabled = p_fEnable;
			listDatabase.Enabled = p_fEnable;
			buttonConnect.Enabled = p_fEnable;
			editUsername.Enabled = p_fEnable;
			editPassword.Enabled = p_fEnable;
			editPath.Enabled = p_fEnable;
			spinInterval.Enabled = p_fEnable;
			buttonStartFeed.Enabled = p_fEnable;
			buttonStopFeed.Enabled = !p_fEnable;
		}

		private void buttonClose_Click(object sender, System.EventArgs e)
		{
			stopThreads();
		}
	}
}
